## cg3 1.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
project(cg3 CXX C)

set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
	set(MASTER_PROJECT ON)
endif ()

# Release or Debug
if(MASTER_PROJECT AND NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release")
endif()

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_MACOSX_RPATH ON)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})

file(READ src/version.hpp _cg3_VERSION_FILE)
string(REGEX REPLACE ".*CG3_VERSION_MAJOR = ([0-9]+).*" "\\1" _cg3_VERSION_MAJOR ${_cg3_VERSION_FILE})
string(REGEX REPLACE ".*CG3_VERSION_MINOR = ([0-9]+).*" "\\1" _cg3_VERSION_MINOR ${_cg3_VERSION_FILE})
string(REGEX REPLACE ".*CG3_VERSION_PATCH = ([0-9]+).*" "\\1" _cg3_VERSION_PATCH ${_cg3_VERSION_FILE})
string(REGEX REPLACE ".*CG3_REVISION = ([0-9]+).*" "\\1" REVISION ${_cg3_VERSION_FILE})
set(CPACK_PACKAGE_VERSION_MAJOR ${_cg3_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${_cg3_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${_cg3_VERSION_PATCH})
set(VERSION "${_cg3_VERSION_MAJOR}.${_cg3_VERSION_MINOR}.${_cg3_VERSION_PATCH}.${REVISION}")

include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Set to OFF to use static library" ON)
option(USE_TCMALLOC "Set to OFF to disable linking against TCMalloc" ON)
option(ENABLE_PYTHON_BINDINGS "Set to ON to build the Python wrapper" OFF)

if(APPLE)
	message(STATUS "Disabling TCMalloc for OS X")
	set(USE_TCMALLOC OFF)
endif()

if(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /permissive- /W4 /MP")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /O2")
	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
	set(CMAKE_C_FLAGS ${CMAKE_CXX_FLAGS})
	set(CMAKE_C_FLAGS_RELEASE ${CMAKE_CXX_FLAGS_RELEASE})
else()
	set(_FLAGS_COMMON "-Wall -Wextra -Wno-missing-field-initializers -Wno-deprecated -Wno-unused-parameter -fPIC")

	include(CheckCCompilerFlag)
	include(CheckCXXCompilerFlag)

	foreach(flag "-Wno-unused-result" "-flto")
		string(REGEX REPLACE "[^A-Za-z0-9]" "-" _flag ${flag})
		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
		if(COMPILER_SUPPORTS_${_flag})
			set(_FLAGS_COMMON "${_FLAGS_COMMON} ${flag}")
		endif()
	endforeach()
	if(COMPILER_SUPPORTS_flto)
		set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -flto")
	endif()

	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_FLAGS_COMMON} -fvisibility-inlines-hidden")
	set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -O0 -g3")
	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${_FLAGS_COMMON}")
	set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -O0 -g3")
	set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O3")

	# Enable latest possible C standard
	foreach(flag "-std=c2x" "-std=c11" "-std=c1x" "-std=c99")
		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
		if(COMPILER_SUPPORTS_${_flag})
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
			break()
		endif()
	endforeach()

	# Require latest possible C++ standard
	foreach(flag "-std=c++20" "-std=c++2a" "-std=c++17" "-std=c++1z" "-std=c++14" "-std=c++1y")
		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
		if(COMPILER_SUPPORTS_${_flag})
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${flag}")
			set(_ENABLED_CXX ${flag})
			break()
		endif()
	endforeach()
	if(NOT _ENABLED_CXX)
		message(FATAL_ERROR "Could not enable at least C++14 (C++1y) - upgrade your compiler")
	endif()

	# Generate pkg-config file
	set(prefix      ${CMAKE_INSTALL_PREFIX})
	set(exec_prefix ${CMAKE_INSTALL_PREFIX})
	set(libdir      ${CMAKE_INSTALL_LIBDIR})
	set(includedir  ${CMAKE_INSTALL_INCLUDEDIR})
	configure_file(cg3.pc.in cg3.pc @ONLY)
	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/cg3.pc" DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

	install(DIRECTORY manual/man/
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
		FILES_MATCHING
		PATTERN "*.1"
		PATTERN ".svn" EXCLUDE)
endif()

include(TestBigEndian)
TEST_BIG_ENDIAN(BIG_ENDIAN)
if(BIG_ENDIAN)
	add_definitions(-DBIG_ENDIAN)
endif()

if(WIN32)
	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX)
	include_directories("include/win32")
else()
	add_definitions(-D_POSIX_C_SOURCE=200112)
	set(POPEN_PLUS_CPP "../include/posix/popen_plus.cpp" "../include/posix/popen_plus.hpp")
	include_directories("include/posix")
endif()

include_directories("include")
include_directories("src")

enable_testing()

add_subdirectory(src)

if(ENABLE_PYTHON_BINDINGS)
	add_subdirectory(python)
endif()

configure_file(scripts/cg3-autobin.pl.in scripts/cg3-autobin.pl @ONLY)
install(PROGRAMS
	"${CMAKE_CURRENT_BINARY_DIR}/scripts/cg3-autobin.pl"
	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-sort"
	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-strictify"
	"${CMAKE_CURRENT_SOURCE_DIR}/scripts/cg-untrace"
	DESTINATION ${CMAKE_INSTALL_BINDIR})

set(ELISPDIR "${CMAKE_INSTALL_DATAROOTDIR}/emacs/site-lisp" CACHE PATH "Where to install Emacs Lisp files")
install(FILES "emacs/cg.el" DESTINATION ${ELISPDIR})

=== src/CMakeLists.txt ===
# Threading, for exec-stream
# There's some weird bug/interaction with recent Apple toolchains and this, so disable for now.
if(NOT APPLE)
	find_package(Threads REQUIRED)
endif()

# Boost
find_path(Boost_LOCAL NAMES boost/config.hpp PATHS "../include" NO_DEFAULT_PATH)
if(Boost_LOCAL)
	set(BOOST_ROOT "../include")
	find_package(Boost 1.53.0)
endif()
if(NOT Boost_FOUND)
	unset(BOOST_ROOT)
	message(STATUS "Did not find Boost locally; trying globally...")
	message(STATUS "If this doesn't work, run ./get-boost.sh and try again.")
	find_package(Boost 1.53.0 REQUIRED)
endif()
include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

# ICU
find_package(ICU REQUIRED)
if(ICU_FOUND)
	if(ICU_VERSION VERSION_LESS "50.0")
		message(FATAL_ERROR "ICU is too old - ${ICU_VERSION} was found, but CG-3 requires 50.0 or newer")
	endif()
	include_directories(${ICU_INCLUDE_DIRS})
	message(STATUS "Found ICU version ${ICU_VERSION}")
endif()

if(NOT CMAKE_BUILD_TYPE STREQUAL Debug AND USE_TCMALLOC)
	find_library(GOOGLE_TCMALLOC_LIB tcmalloc)
	if(GOOGLE_TCMALLOC_LIB)
		message(STATUS "Found tcmalloc: ${GOOGLE_TCMALLOC_LIB}")
		set(GOOGLE_TCMALLOC_ENABLED 1)
	else()
		message(STATUS "Can't find tcmalloc - skipping")
	endif()
endif()

macro(cg3_link target)
	if(GOOGLE_TCMALLOC_ENABLED)
		target_link_libraries(${target} ${GOOGLE_TCMALLOC_LIB})
	endif()

	if(WIN32)
		target_link_libraries(${target} "wsock32.lib")
	endif()

	target_link_libraries(${target} ${CMAKE_THREAD_LIBS_INIT})
	target_link_libraries(${target} ${Boost_LIBRARIES})
	target_link_libraries(${target} ${ICU_LIBRARIES} ${ICU_IO_LIBRARIES} ${ICU_I18N_LIBRARIES})
endmacro()

set(LIBCG3_HEADERS
	AST.hpp
	BinaryGrammar.hpp
	Cohort.hpp
	CohortIterator.hpp
	ContextualTest.hpp
	Grammar.hpp
	GrammarApplicator.hpp
	GrammarWriter.hpp
	Relabeller.hpp
	MweSplitApplicator.hpp
	IGrammarParser.hpp
	Reading.hpp
	Rule.hpp
	Set.hpp
	SingleWindow.hpp
	Strings.hpp
	Tag.hpp
	TagTrie.hpp
	TextualParser.hpp
	Window.hpp
	bloomish.hpp
	cg3.h
	flat_unordered_map.hpp
	flat_unordered_set.hpp
	inlines.hpp
	interval_vector.hpp
	parser_helpers.hpp
	process.hpp
	scoped_stack.hpp
	sorted_vector.hpp
	stdafx.hpp
	streambuf.hpp
	uextras.hpp
	version.hpp
	)
set(LIBCG3_SOURCES
	BinaryGrammar.cpp
	BinaryGrammar_read.cpp
	BinaryGrammar_read_10043.cpp
	BinaryGrammar_write.cpp
	Cohort.cpp
	CohortIterator.cpp
	ContextualTest.cpp
	Grammar.cpp
	GrammarApplicator.cpp
	GrammarApplicator_matchSet.cpp
	GrammarApplicator_reflow.cpp
	GrammarApplicator_runContextualTest.cpp
	GrammarApplicator_runGrammar.cpp
	GrammarApplicator_runRules.cpp
	GrammarWriter.cpp
	Relabeller.cpp
	MweSplitApplicator.cpp
	Reading.cpp
	Rule.cpp
	Set.cpp
	SingleWindow.cpp
	Strings.cpp
	Tag.cpp
	TextualParser.cpp
	Window.cpp
	uextras.cpp
	${POPEN_PLUS_CPP}
	${LIBCG3_HEADERS}
	)
if(MSVC)
	set(LIBCG3_SOURCES
		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
		${LIBCG3_SOURCES}
		)
endif()

add_library(cg3 libcg3.cpp ${LIBCG3_SOURCES})
set_target_properties(cg3 PROPERTIES SOVERSION ${_cg3_VERSION_MAJOR})
cg3_link(cg3)
set(LINKLIB cg3)

add_executable(cg-comp cg_comp.cpp)
cg3_link(cg-comp)
target_link_libraries(cg-comp ${LINKLIB})

add_executable(cg-proc
	cg_proc.cpp
	ApertiumApplicator.cpp
	ApertiumApplicator.hpp
	MatxinApplicator.cpp
	MatxinApplicator.hpp
	)
cg3_link(cg-proc)
target_link_libraries(cg-proc ${LINKLIB})

add_executable(cg-relabel cg-relabel.cpp)
cg3_link(cg-relabel)
target_link_libraries(cg-relabel ${LINKLIB})

add_executable(cg-conv
	cg_conv.cpp
	ApertiumApplicator.cpp
	ApertiumApplicator.hpp
	MatxinApplicator.cpp
	MatxinApplicator.hpp
	FormatConverter.cpp
	FormatConverter.hpp
	FSTApplicator.cpp
	FSTApplicator.hpp
	NicelineApplicator.cpp
	NicelineApplicator.hpp
	PlaintextApplicator.cpp
	PlaintextApplicator.hpp
	options_conv.hpp
	)
cg3_link(cg-conv)
target_link_libraries(cg-conv ${LINKLIB})

add_executable(cg-mwesplit cg-mwesplit.cpp)
cg3_link(cg-mwesplit)
target_link_libraries(cg-mwesplit ${LINKLIB})

add_executable(vislcg3 main.cpp options.hpp)
cg3_link(vislcg3)
target_link_libraries(vislcg3 ${LINKLIB})

add_executable(test_libcg3 test_libcg3.c)
target_link_libraries(test_libcg3 ${LINKLIB})

if(APPLE)
	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit vislcg3)
		set("_file_${t}" $<TARGET_FILE:${t}>)
		add_custom_command(
			TARGET ${t}
			POST_BUILD
			COMMAND install_name_tool -change libcg3.0.dylib @rpath/libcg3.0.dylib ${_file_${t}}
			COMMAND install_name_tool -add_rpath @executable_path/ ${_file_${t}}
			COMMAND install_name_tool -add_rpath @executable_path/../${CMAKE_INSTALL_LIBDIR} ${_file_${t}}
			COMMAND install_name_tool -add_rpath @loader_path/../${CMAKE_INSTALL_LIBDIR} ${_file_${t}}
			COMMENT "Adding @rpath to ${t}"
			VERBATIM
		)
	endforeach()
endif()

add_test(t_libcg3 test_libcg3 "${CMAKE_CURRENT_SOURCE_DIR}/../test/T_Select/grammar.cg3")

install(TARGETS cg3 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES cg3.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv vislcg3 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
cg3 (1.3.1-2build3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:32:22 +0100

cg3 (1.3.1-2build2) focal; urgency=medium

  * No-change rebuild against libicu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 16:34:50 +0000

cg3 (1.3.1-2build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:30:47 +0000

cg3 (1.3.1-2) unstable; urgency=low

  * Source only upload.

 -- Kartik Mistry <kartik@debian.org>  Wed, 04 Dec 2019 17:54:25 +0530

cg3 (1.3.1-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream
    + Added Python module
    + Added cg3-dev metapackage
  * Updated Standards-Version to 4.4.1
  * Bumped dh to 12

  [ Kartik Mistry ]
  * Added debian/gitlab-ci.yml

 -- Kartik Mistry <kartik@debian.org>  Sun, 13 Oct 2019 18:07:47 +0530

=== debian/control ===
Source: cg3
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tino Didriksen <tino@didriksen.cc>,
           Kartik Mistry <kartik@debian.org>
Build-Depends: cmake,
               debhelper (>= 12),
               dh-python,
               libboost-dev,
               libicu-dev,
               python3-dev,
               python3-setuptools,
               swig
Standards-Version: 4.4.1
Homepage: https://visl.sdu.dk/cg3.html
Vcs-Git: https://salsa.debian.org/science-team/cg3.git
Vcs-Browser: https://salsa.debian.org/science-team/cg3

Package: cg3
Architecture: any
Depends: libcg3-1 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Provides: vislcg3
Conflicts: vislcg3
Replaces: vislcg3
Suggests: libdigest-sha-perl
Description: Tools for using the 3rd edition of Constraint Grammar (CG-3)
 Constraint Grammar compiler and applicator for the 3rd edition of CG
 that is developed and maintained by VISL SDU and GrammarSoft ApS.
 .
 CG-3 can be used for disambiguation of morphology, syntax, semantics, etc;
 dependency markup, target language lemma choice for MT, QA systems, and
 much more. The core idea is that you choose what to do based on the whole
 available context, as opposed to n-grams.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

Package: cg3-dev
Architecture: all
Depends: cg3 (>= ${binary:Version}),
         libcg3-dev (>= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Metapackage providing both CG-3 CLI dev tools and dev library
 Development files to use the CG-3 CLI tools and library API.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

Package: libcg3-1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: libcg3
Conflicts: libcg3
Replaces: libcg3
Description: Runtime for CG-3
 Runtime library for applications using the CG-3 API.
 .
 It is recommended to instrument the CLI tools instead of using this API.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

Package: libcg3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libcg3-1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Headers and shared files to develop using the CG-3 library
 Development files to use the CG-3 API.
 .
 It is recommended to instrument the CLI tools instead of using this API.
 .
 See https://visl.sdu.dk/cg3.html for more documentation

Package: python3-cg3
Architecture: any
Section: python
Provides: ${python3:Provides}
XB-Python-Version: ${python3:Versions}
Depends: libcg3-1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Wrapper for CG-3
 Wrapper to use CG-3 from Python

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
export DH_OPTIONS
export LC_ALL=C.UTF-8

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_PYTHON_BINDINGS=ON "-DPYTHON_INSTALL_PARAMS=--no-compile --prefix /usr --install-layout deb --root $(CURDIR)/debian/tmp"

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR) -type f -name '*.pyc' -exec rm -f '{}' \;
	find $(CURDIR) -type f -name '*.pyo' -exec rm -f '{}' \;
	find $(CURDIR) -type f -name '*.la' -exec rm -f '{}' \;

override_dh_missing:
	dh_missing --fail-missing

## cg3 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,7 @@
 endif()
 
 if(MSVC)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /permissive- /W4 /MP")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /Zc:__cplusplus /permissive- /W4 /MP")
 	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /O2")
 	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
 	set(CMAKE_C_FLAGS ${CMAKE_CXX_FLAGS})
@@ -51,7 +51,7 @@
 	include(CheckCXXCompilerFlag)
 
 	foreach(flag "-Wno-unused-result" "-flto")
-		string(REGEX REPLACE "[^A-Za-z0-9]" "-" _flag ${flag})
+		string(REGEX REPLACE "[^A-Za-z0-9]" "" _flag ${flag})
 		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
 			set(_FLAGS_COMMON "${_FLAGS_COMMON} ${flag}")
@@ -70,7 +70,7 @@
 
 	# Enable latest possible C standard
 	foreach(flag "-std=c2x" "-std=c11" "-std=c1x" "-std=c99")
-		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
+		string(REGEX REPLACE "[^a-z0-9]" "" _flag ${flag})
 		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
 			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")

=== python/CMakeLists.txt ===
find_package(SWIG 3.0 REQUIRED)
find_package(PythonInterp 3.5 REQUIRED)

set(PYTHON_FILE "constraint_grammar.py")
set(CPP_WRAP_FILE "constraint_grammar_wrap.cpp")
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/cg3.py" "from constraint_grammar import *\n")

configure_file(constraint_grammar.i.in constraint_grammar.i @ONLY)
configure_file(setup.py.in setup.py)

add_custom_command(OUTPUT ${CPP_WRAP_FILE} ${PYTHON_FILE}
	COMMAND ${PYTHON_EXECUTABLE} setup.py build
	COMMENT "Building ${PYTHON_FILE}"
)

add_custom_target(wrapper ALL
	DEPENDS ${CPP_WRAP_FILE} ${PYTHON_FILE}
	VERBATIM
)

if(NOT PYTHON_INSTALL_PARAMS)
	set(PYTHON_INSTALL_PARAMS "--prefix=${CMAKE_INSTALL_PREFIX} --root=\$ENV{DESTDIR}/")
endif()

set(INSTALL_WRAPPER "${PYTHON_EXECUTABLE} setup.py install ${PYTHON_INSTALL_PARAMS}")
install(CODE "execute_process(COMMAND ${INSTALL_WRAPPER} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -119,7 +119,7 @@
 	${POPEN_PLUS_CPP}
 	${LIBCG3_HEADERS}
 	)
-if(MSVC)
+if(WIN32)
 	set(LIBCG3_SOURCES
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
@@ -165,6 +165,7 @@
 	PlaintextApplicator.cpp
 	PlaintextApplicator.hpp
 	options_conv.hpp
+	options_parser.hpp
 	)
 cg3_link(cg-conv)
 target_link_libraries(cg-conv ${LINKLIB})
@@ -173,7 +174,11 @@
 cg3_link(cg-mwesplit)
 target_link_libraries(cg-mwesplit ${LINKLIB})
 
-add_executable(vislcg3 main.cpp options.hpp)
+add_executable(vislcg3
+	main.cpp
+	options.hpp
+	options_parser.hpp
+	)
 cg3_link(vislcg3)
 target_link_libraries(vislcg3 ${LINKLIB})

=== debian/changelog ===
cg3 (1.3.2-1build2) jammy; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Feb 2022 05:54:22 +0100

cg3 (1.3.2-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:08:26 +0000

cg3 (1.3.2-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream
  * debian/control:
    + Updated Standards-Version to 4.5.1

  [ Kartik Mistry ]
  * Updated debian/watch file.
  * Removed unused debian/libcg3-1.lintian-overrides.

 -- Kartik Mistry <kartik@debian.org>  Tue, 15 Dec 2020 13:22:22 +0530

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,22 @@
 Source: cg3
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Tino Didriksen <tino@didriksen.cc>,
            Kartik Mistry <kartik@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 12),
+               debhelper-compat (= 13),
                dh-python,
                libboost-dev,
                libicu-dev,
                python3-dev,
                python3-setuptools,
                swig
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Homepage: https://visl.sdu.dk/cg3.html
 Vcs-Git: https://salsa.debian.org/science-team/cg3.git
 Vcs-Browser: https://salsa.debian.org/science-team/cg3
+Rules-Requires-Root: no
 
 Package: cg3
 Architecture: any

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
    https://github.com/TinoDidriksen/cg3/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## cg3 1.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -122,8 +122,15 @@
 	include_directories("include/posix")
 endif()
 
+add_definitions(-DUNISTR_FROM_CHAR_EXPLICIT=explicit -DUNISTR_FROM_STRING_EXPLICIT=explicit)
 include_directories("include")
 include_directories("src")
+
+include(CheckIncludeFileCXX)
+CHECK_INCLUDE_FILE_CXX(string_view HAS_SV)
+if(HAS_SV)
+	add_definitions(-DHAS_SV)
+endif()
 
 enable_testing()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,6 +86,7 @@
 	sorted_vector.hpp
 	stdafx.hpp
 	streambuf.hpp
+	string_view.hpp
 	uextras.hpp
 	version.hpp
 	)

=== debian/changelog ===
cg3 (1.3.6-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream.
  * debian/control:
    + Updated Standards-Version to 4.6.0

  [ Kartik Mistry ]
  * debian/control:
    + Removed XB-Python-Version field.
    + python3-cg3: Updated extended description.

 -- Kartik Mistry <kartik@debian.org>  Mon, 14 Mar 2022 10:00:06 +0530

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-dev,
                python3-setuptools,
                swig
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://visl.sdu.dk/cg3.html
 Vcs-Git: https://salsa.debian.org/science-team/cg3.git
 Vcs-Browser: https://salsa.debian.org/science-team/cg3
@@ -83,10 +83,12 @@
 Architecture: any
 Section: python
 Provides: ${python3:Provides}
-XB-Python-Version: ${python3:Versions}
 Depends: libcg3-1 (= ${binary:Version}),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
 Description: Wrapper for CG-3
- Wrapper to use CG-3 from Python
+ Constraint Grammar compiler and applicator for the 3rd edition of CG
+ that is developed and maintained by VISL SDU and GrammarSoft ApS.
+ .
+ This package provides wrapper to use CG-3 from Python.

=== debian/watch ===
version=4
https://github.com/GrammarSoft/cg3/releases \
 .*/@PACKAGE@-(\d[\d.]*)\.tar\.bz2 debian uupdate

## cg3 1.3.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
 	endforeach()
 
 	# Require latest possible C++ standard
-	foreach(flag "-std=c++20" "-std=c++2a" "-std=c++17" "-std=c++1z" "-std=c++14" "-std=c++1y")
+	foreach(flag "-std=c++23" "-std=c++2b" "-std=c++20" "-std=c++2a" "-std=c++17")
 		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
 		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
@@ -89,7 +89,7 @@
 		endif()
 	endforeach()
 	if(NOT _ENABLED_CXX)
-		message(FATAL_ERROR "Could not enable at least C++14 (C++1y) - upgrade your compiler")
+		message(FATAL_ERROR "Could not enable at least C++17 - upgrade your compiler")
 	endif()
 
 	# Generate pkg-config file
@@ -114,7 +114,7 @@
 endif()
 
 if(WIN32)
-	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX)
+	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX -D_SILENCE_CXX20_CISO646_REMOVED_WARNING)
 	include_directories("include/win32")
 else()
 	add_definitions(-D_POSIX_C_SOURCE=200112)
@@ -125,12 +125,6 @@
 add_definitions(-DUNISTR_FROM_CHAR_EXPLICIT=explicit -DUNISTR_FROM_STRING_EXPLICIT=explicit)
 include_directories("include")
 include_directories("src")
-
-include(CheckIncludeFileCXX)
-CHECK_INCLUDE_FILE_CXX(string_view HAS_SV)
-if(HAS_SV)
-	add_definitions(-DHAS_SV)
-endif()
 
 enable_testing()

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,11 @@
 set(CPP_WRAP_FILE "constraint_grammar_wrap.cpp")
 file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/cg3.py" "from constraint_grammar import *\n")
 
+set(BUILD_DEFS "")
+get_directory_property(_defs DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} COMPILE_DEFINITIONS)
+foreach(d ${_defs})
+	set(BUILD_DEFS "${BUILD_DEFS} -D${d}")
+endforeach()
 configure_file(constraint_grammar.i.in constraint_grammar.i @ONLY)
 configure_file(setup.py.in setup.py)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,7 +86,6 @@
 	sorted_vector.hpp
 	stdafx.hpp
 	streambuf.hpp
-	string_view.hpp
 	uextras.hpp
 	version.hpp
 	)
@@ -124,6 +123,8 @@
 	set(LIBCG3_SOURCES
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
+		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.cpp"
+		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.h"
 		${LIBCG3_SOURCES}
 		)
 endif()

=== debian/changelog ===
cg3 (1.3.9-1) unstable; urgency=medium

  * Update to latest upstream
  * debian/
    + control: Update S-V to 4.6.1
    + rules: Enable link-time optimization
    + watch: Use Github API instead

 -- Tino Didriksen <tino@didriksen.cc>  Fri, 07 Oct 2022 19:38:36 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-dev,
                python3-setuptools,
                swig
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://visl.sdu.dk/cg3.html
 Vcs-Git: https://salsa.debian.org/science-team/cg3.git
 Vcs-Browser: https://salsa.debian.org/science-team/cg3

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DH_OPTIONS
 export LC_ALL=C.UTF-8
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export "DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto"
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -13,7 +13,7 @@
 	dh $@ --with python3
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DENABLE_PYTHON_BINDINGS=ON "-DPYTHON_INSTALL_PARAMS=--no-compile --prefix /usr --install-layout deb --root $(CURDIR)/debian/tmp"
+	dh_auto_configure -- -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON -DENABLE_PYTHON_BINDINGS=ON "-DPYTHON_INSTALL_PARAMS=--no-compile --prefix /usr --install-layout deb --root $(CURDIR)/debian/tmp"
 
 override_dh_auto_install:
 	dh_auto_install

=== debian/watch ===
version=4
opts="searchmode=plain" \
  https://api.github.com/repos/grammarsoft/@PACKAGE@/releases \
  https://github.com/grammarsoft/@PACKAGE@/releases/download/v(?:\d[\d.]*)/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## cg3 1.4.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,6 @@
 set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 set(CMAKE_MACOSX_RPATH ON)
-set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
 
 file(READ src/version.hpp _cg3_VERSION_FILE)
 string(REGEX REPLACE ".*CG3_VERSION_MAJOR = ([0-9]+).*" "\\1" _cg3_VERSION_MAJOR ${_cg3_VERSION_FILE})
@@ -30,13 +29,7 @@
 include(GNUInstallDirs)
 
 option(BUILD_SHARED_LIBS "Set to OFF to use static library" ON)
-option(USE_TCMALLOC "Set to OFF to disable linking against TCMalloc" ON)
 option(ENABLE_PYTHON_BINDINGS "Set to ON to build the Python wrapper" OFF)
-
-if(APPLE)
-	message(STATUS "Disabling TCMalloc for OS X")
-	set(USE_TCMALLOC OFF)
-endif()
 
 if(MSVC)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /Zc:__cplusplus /permissive- /W4 /MP")
@@ -113,13 +106,29 @@
 	add_definitions(-DBIG_ENDIAN)
 endif()
 
+CHECK_INCLUDE_FILE_CXX(filesystem HAS_FS)
+if(HAS_FS)
+	add_definitions(-DHAS_FS)
+endif()
+
+# std::filesystem is in a separate library until g++ 9
+if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
+	set(STDFS_LIB stdc++fs)
+endif()
+
 if(WIN32)
 	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX -D_SILENCE_CXX20_CISO646_REMOVED_WARNING)
-	include_directories("include/win32")
+	include_directories("include/getopt" "include/wordexp")
 else()
-	add_definitions(-D_POSIX_C_SOURCE=200112)
+	add_definitions(-D_POSIX_C_SOURCE=200112 -DBOOST_NO_CXX98_FUNCTION_BASE=1)
 	set(POPEN_PLUS_CPP "../include/posix/popen_plus.cpp" "../include/posix/popen_plus.hpp")
 	include_directories("include/posix")
+endif()
+if(EMSCRIPTEN)
+	include_directories("include/wordexp")
+	set(CMAKE_EXECUTABLE_SUFFIX ".html")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g3 -gsource-map")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g3 -gsource-map")
 endif()
 
 add_definitions(-DUNISTR_FROM_CHAR_EXPLICIT=explicit -DUNISTR_FROM_STRING_EXPLICIT=explicit)

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,10 @@
 find_package(SWIG 3.0 REQUIRED)
-find_package(PythonInterp 3.5 REQUIRED)
+if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.12.0")
+	find_package(Python 3.5 REQUIRED)
+	set(PYTHON_EXECUTABLE ${Python_EXECUTABLE})
+else()
+	find_package(PythonInterp 3.5 REQUIRED)
+endif()
 
 set(PYTHON_FILE "constraint_grammar.py")
 set(CPP_WRAP_FILE "constraint_grammar_wrap.cpp")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,49 +8,52 @@
 find_path(Boost_LOCAL NAMES boost/config.hpp PATHS "../include" NO_DEFAULT_PATH)
 if(Boost_LOCAL)
 	set(BOOST_ROOT "../include")
-	find_package(Boost 1.53.0)
+	find_package(Boost 1.62.0)
 endif()
 if(NOT Boost_FOUND)
 	unset(BOOST_ROOT)
 	message(STATUS "Did not find Boost locally; trying globally...")
 	message(STATUS "If this doesn't work, run ./get-boost.sh and try again.")
-	find_package(Boost 1.53.0 REQUIRED)
+	find_package(Boost 1.62.0 REQUIRED)
 endif()
 include_directories(${Boost_INCLUDE_DIRS})
 link_directories(${Boost_LIBRARY_DIRS})
 
 # ICU
-find_package(ICU REQUIRED)
+find_package(ICU 59.0 COMPONENTS i18n io uc data REQUIRED)
 if(ICU_FOUND)
-	if(ICU_VERSION VERSION_LESS "50.0")
-		message(FATAL_ERROR "ICU is too old - ${ICU_VERSION} was found, but CG-3 requires 50.0 or newer")
-	endif()
 	include_directories(${ICU_INCLUDE_DIRS})
 	message(STATUS "Found ICU version ${ICU_VERSION}")
 endif()
-
-if(NOT CMAKE_BUILD_TYPE STREQUAL Debug AND USE_TCMALLOC)
-	find_library(GOOGLE_TCMALLOC_LIB tcmalloc)
-	if(GOOGLE_TCMALLOC_LIB)
-		message(STATUS "Found tcmalloc: ${GOOGLE_TCMALLOC_LIB}")
-		set(GOOGLE_TCMALLOC_ENABLED 1)
-	else()
-		message(STATUS "Can't find tcmalloc - skipping")
+link_directories(${ICU_LIBRARY_DIRS})
+
+if(VCPKG_TOOLCHAIN)
+	find_path(SQLITE3_INCLUDE_DIRS sqlite3.h REQUIRED)
+	find_library(SQLITE3_LIBRARIES sqlite3 REQUIRED)
+else()
+	find_package(PkgConfig REQUIRED)
+	pkg_search_module(SQLITE3 REQUIRED sqlite3)
+endif()
+include_directories(${SQLITE3_INCLUDE_DIRS})
+link_directories(${SQLITE3_LIBRARY_DIRS})
+
+macro(cg3_link target)
+	if(EMSCRIPTEN)
+		target_link_options(${target} PRIVATE
+			-sEXPORTED_RUNTIME_METHODS=ccall,cwrap
+			# Generated with: pcregrep -o 'cg3_\S+\(' src/cg3.h | perl -wpne "s/\(//g; s/^/'_/; s/\n/',/;"
+			-sEXPORTED_FUNCTIONS=['_cg3_init','_cg3_init','_cg3_cleanup','_cg3_cleanup','_cg3_grammar_load','_cg3_grammar_load_buffer','_cg3_grammar_free','_cg3_applicator_create','_cg3_applicator_setflags','_cg3_applicator_setoption','_cg3_applicator_setoption','_cg3_applicator_setoption','_cg3_applicator_free','_cg3_run_grammar_on_text','_cg3_run_grammar_on_text_fns','_cg3_mwesplitapplicator_create','_cg3_sentence_new','_cg3_sentence_copy','_cg3_sentence_runrules','_cg3_sentence_addcohort','_cg3_sentence_numcohorts','_cg3_sentence_getcohort','_cg3_sentence_free','_cg3_cohort_create','_cg3_cohort_setwordform','_cg3_cohort_getwordform','_cg3_cohort_getid','_cg3_cohort_setdependency','_cg3_cohort_getdependency','_cg3_cohort_addreading','_cg3_cohort_numreadings','_cg3_cohort_getreading','_cg3_cohort_free','_cg3_reading_create','_cg3_reading_addtag','_cg3_reading_numtags','_cg3_reading_gettag','_cg3_reading_numtraces','_cg3_reading_gettrace','_cg3_reading_free','_cg3_subreading_create','_cg3_reading_setsubreading','_cg3_reading_numsubreadings','_cg3_reading_getsubreading','_cg3_subreading_free','_cg3_tag_create_u','_cg3_tag_create_u8','_cg3_tag_create_u16','_cg3_tag_create_u32','_cg3_tag_create_w','_cg3_tag_gettext_u','_cg3_tag_gettext_u8','_cg3_tag_gettext_u16','_cg3_tag_gettext_u32','_cg3_tag_gettext_w','_cg3_cohort_numdelreadings','_cg3_cohort_getdelreading','_cg3_reading_gettrace_ruletype']
+			-sASSERTIONS=1
+			)
 	endif()
-endif()
-
-macro(cg3_link target)
-	if(GOOGLE_TCMALLOC_ENABLED)
-		target_link_libraries(${target} ${GOOGLE_TCMALLOC_LIB})
-	endif()
-
-	if(WIN32)
-		target_link_libraries(${target} "wsock32.lib")
-	endif()
-
-	target_link_libraries(${target} ${CMAKE_THREAD_LIBS_INIT})
-	target_link_libraries(${target} ${Boost_LIBRARIES})
-	target_link_libraries(${target} ${ICU_LIBRARIES} ${ICU_IO_LIBRARIES} ${ICU_I18N_LIBRARIES})
+
+	target_link_libraries(${target}
+		${CMAKE_THREAD_LIBS_INIT}
+		${STDFS_LIB}
+		${Boost_LIBRARIES}
+		${ICU_LIBRARIES}
+		${SQLITE3_LIBRARIES}
+		)
 endmacro()
 
 set(LIBCG3_HEADERS
@@ -65,6 +68,7 @@
 	Relabeller.hpp
 	MweSplitApplicator.hpp
 	IGrammarParser.hpp
+	Profiler.hpp
 	Reading.hpp
 	Rule.hpp
 	Set.hpp
@@ -81,6 +85,7 @@
 	inlines.hpp
 	interval_vector.hpp
 	parser_helpers.hpp
+	pool.hpp
 	process.hpp
 	scoped_stack.hpp
 	sorted_vector.hpp
@@ -99,6 +104,7 @@
 	ContextualTest.cpp
 	Grammar.cpp
 	GrammarApplicator.cpp
+	GrammarApplicator_context.cpp
 	GrammarApplicator_matchSet.cpp
 	GrammarApplicator_reflow.cpp
 	GrammarApplicator_runContextualTest.cpp
@@ -107,6 +113,7 @@
 	GrammarWriter.cpp
 	Relabeller.cpp
 	MweSplitApplicator.cpp
+	Profiler.cpp
 	Reading.cpp
 	Rule.cpp
 	Set.cpp
@@ -119,12 +126,17 @@
 	${POPEN_PLUS_CPP}
 	${LIBCG3_HEADERS}
 	)
+if(WIN32 OR EMSCRIPTEN)
+	set(LIBCG3_SOURCES
+		"${CMAKE_SOURCE_DIR}/include/wordexp/wordexp.cpp"
+		"${CMAKE_SOURCE_DIR}/include/wordexp/wordexp.h"
+		${LIBCG3_SOURCES}
+		)
+endif()
 if(WIN32)
 	set(LIBCG3_SOURCES
-		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
-		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
-		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.cpp"
-		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.h"
+		"${CMAKE_SOURCE_DIR}/include/getopt/getopt.cpp"
+		"${CMAKE_SOURCE_DIR}/include/getopt/getopt.h"
 		${LIBCG3_SOURCES}
 		)
 endif()
@@ -134,12 +146,12 @@
 cg3_link(cg3)
 set(LINKLIB cg3)
 
-add_executable(cg-comp cg_comp.cpp)
+add_executable(cg-comp cg-comp.cpp)
 cg3_link(cg-comp)
 target_link_libraries(cg-comp ${LINKLIB})
 
 add_executable(cg-proc
-	cg_proc.cpp
+	cg-proc.cpp
 	ApertiumApplicator.cpp
 	ApertiumApplicator.hpp
 	MatxinApplicator.cpp
@@ -153,7 +165,7 @@
 target_link_libraries(cg-relabel ${LINKLIB})
 
 add_executable(cg-conv
-	cg_conv.cpp
+	cg-conv.cpp
 	ApertiumApplicator.cpp
 	ApertiumApplicator.hpp
 	MatxinApplicator.cpp
@@ -176,6 +188,14 @@
 cg3_link(cg-mwesplit)
 target_link_libraries(cg-mwesplit ${LINKLIB})
 
+add_executable(cg-annotate cg-annotate.cpp)
+cg3_link(cg-annotate)
+target_link_libraries(cg-annotate ${LINKLIB})
+
+add_executable(cg-merge-annotations cg-merge-annotations.cpp)
+cg3_link(cg-merge-annotations)
+target_link_libraries(cg-merge-annotations ${LINKLIB})
+
 add_executable(vislcg3
 	main.cpp
 	options.hpp
@@ -188,7 +208,7 @@
 target_link_libraries(test_libcg3 ${LINKLIB})
 
 if(APPLE)
-	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit vislcg3)
+	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit cg-annotate cg-merge-annotations vislcg3)
 		set("_file_${t}" $<TARGET_FILE:${t}>)
 		add_custom_command(
 			TARGET ${t}
@@ -207,4 +227,4 @@
 
 install(TARGETS cg3 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES cg3.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv vislcg3 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv cg-annotate cg-merge-annotations vislcg3 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
cg3 (1.4.6-1build2) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 19:05:56 +0000

cg3 (1.4.6-1build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:05:15 +0100

cg3 (1.4.6-1) unstable; urgency=medium

  * Update to latest upstream
  * Handle locating Python with CMake >= 3.12.0 (Closes: #1042249)

 -- Tino Didriksen <tino@didriksen.cc>  Fri, 04 Aug 2023 12:52:03 +0200

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,8 @@
                dh-python,
                libboost-dev,
                libicu-dev,
+               libsqlite3-dev,
+               pkg-config,
                python3-dev,
                python3-setuptools,
                swig

## cg3 1.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.0 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.12 FATAL_ERROR)
 cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
 project(cg3 CXX C)
 
@@ -30,6 +30,7 @@
 
 option(BUILD_SHARED_LIBS "Set to OFF to use static library" ON)
 option(ENABLE_PYTHON_BINDINGS "Set to ON to build the Python wrapper" OFF)
+option(ENABLE_PROFILING "Set to OFF to disable profiling, and thus the SQLite dependency" ON)
 
 if(MSVC)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /Zc:__cplusplus /permissive- /W4 /MP")
@@ -106,6 +107,7 @@
 	add_definitions(-DBIG_ENDIAN)
 endif()
 
+include(CheckIncludeFileCXX)
 CHECK_INCLUDE_FILE_CXX(filesystem HAS_FS)
 if(HAS_FS)
 	add_definitions(-DHAS_FS)
@@ -116,8 +118,12 @@
 	set(STDFS_LIB stdc++fs)
 endif()
 
+if(NOT ENABLE_PROFILING)
+	add_definitions(-DDISABLE_PROFILING=1)
+endif()
+
 if(WIN32)
-	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX -D_SILENCE_CXX20_CISO646_REMOVED_WARNING)
+	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX -D_SILENCE_CXX20_CISO646_REMOVED_WARNING -D_USE_MATH_DEFINES)
 	include_directories("include/getopt" "include/wordexp")
 else()
 	add_definitions(-D_POSIX_C_SOURCE=200112 -DBOOST_NO_CXX98_FUNCTION_BASE=1)

=== src/CMakeLists.txt ===
if(EMSCRIPTEN)
	message(STATUS "Detected EMSCRIPTEN: skipping local library discovery and using Emscripten ports")
	# Emscripten ports flags for Boost, ICU, SQLite3:
	set(USE_FLAGS "--use-port=boost_headers --use-port=icu --use-port=sqlite3")

	# Append to CXX flags, exe linker flags, and shared linker flags.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${USE_FLAGS}")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${USE_FLAGS}")
	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${USE_FLAGS}")

	# No threading for Emscripten build
	set(CMAKE_THREAD_LIBS_INIT "")
else()
	# Threading, for exec-stream
	# There's some weird bug/interaction with recent Apple toolchains and this, so disable for now.
	if(NOT APPLE)
		find_package(Threads REQUIRED)
	else()
		# See https://trac.macports.org/ticket/71642
		cmake_policy(SET CMP0167 OLD)
	endif()

	# Boost
	find_path(Boost_LOCAL NAMES boost/config.hpp PATHS "../include" NO_DEFAULT_PATH)
	if(Boost_LOCAL)
		set(BOOST_ROOT "../include")
		find_package(Boost 1.62.0)
	endif()
	if(NOT Boost_FOUND)
		unset(BOOST_ROOT)
		message(STATUS "Did not find Boost locally; trying globally...")
		message(STATUS "If this doesn't work, run ./get-boost.sh and try again.")
		find_package(Boost 1.62.0 REQUIRED)
	endif()
	include_directories(${Boost_INCLUDE_DIRS})
	link_directories(${Boost_LIBRARY_DIRS})

	# ICU
	find_package(ICU 59.0 COMPONENTS i18n io uc data REQUIRED)
	if(ICU_FOUND)
		include_directories(${ICU_INCLUDE_DIRS})
		message(STATUS "Found ICU version ${ICU_VERSION}")
	endif()
	link_directories(${ICU_LIBRARY_DIRS})

	if(ENABLE_PROFILING)
		if(VCPKG_TOOLCHAIN)
			find_path(SQLITE3_INCLUDE_DIRS sqlite3.h REQUIRED)
			find_library(SQLITE3_LIBRARIES sqlite3 REQUIRED)
		else()
			find_package(PkgConfig REQUIRED)
			pkg_search_module(SQLITE3 REQUIRED sqlite3)
		endif()
		include_directories(${SQLITE3_INCLUDE_DIRS})
		link_directories(${SQLITE3_LIBRARY_DIRS})
	endif()
endif()

macro(cg3_link target)
	if(EMSCRIPTEN)
		target_link_options(${target} PRIVATE
			-sEXPORTED_RUNTIME_METHODS=ccall,cwrap
			# Generated with: pcregrep -o 'cg3_\S+\(' src/cg3.h | perl -wpne "s/\(//g; s/^/'_/; s/\n/',/;"
			-sEXPORTED_FUNCTIONS=['_cg3_init','_cg3_init','_cg3_cleanup','_cg3_cleanup','_cg3_grammar_load','_cg3_grammar_load_buffer','_cg3_grammar_free','_cg3_applicator_create','_cg3_applicator_setflags','_cg3_applicator_setoption','_cg3_applicator_setoption','_cg3_applicator_setoption','_cg3_applicator_free','_cg3_run_grammar_on_text','_cg3_run_grammar_on_text_fns','_cg3_mwesplitapplicator_create','_cg3_sentence_new','_cg3_sentence_copy','_cg3_sentence_runrules','_cg3_sentence_addcohort','_cg3_sentence_numcohorts','_cg3_sentence_getcohort','_cg3_sentence_free','_cg3_cohort_create','_cg3_cohort_setwordform','_cg3_cohort_getwordform','_cg3_cohort_getid','_cg3_cohort_setdependency','_cg3_cohort_getdependency','_cg3_cohort_addreading','_cg3_cohort_numreadings','_cg3_cohort_getreading','_cg3_cohort_free','_cg3_reading_create','_cg3_reading_addtag','_cg3_reading_numtags','_cg3_reading_gettag','_cg3_reading_numtraces','_cg3_reading_gettrace','_cg3_reading_free','_cg3_subreading_create','_cg3_reading_setsubreading','_cg3_reading_numsubreadings','_cg3_reading_getsubreading','_cg3_subreading_free','_cg3_tag_create_u','_cg3_tag_create_u8','_cg3_tag_create_u16','_cg3_tag_create_u32','_cg3_tag_create_w','_cg3_tag_gettext_u','_cg3_tag_gettext_u8','_cg3_tag_gettext_u16','_cg3_tag_gettext_u32','_cg3_tag_gettext_w','_cg3_cohort_numdelreadings','_cg3_cohort_getdelreading','_cg3_reading_gettrace_ruletype']
			-sASSERTIONS=1
			)
	else()
		target_link_libraries(${target}
			${CMAKE_THREAD_LIBS_INIT}
			${STDFS_LIB}
			${Boost_LIBRARIES}
			${ICU_LIBRARIES}
			${SQLITE3_LIBRARIES}
			)
	endif()
endmacro()

set(LIBCG3_SOURCES
	AST.hpp
	ApertiumApplicator.cpp
	ApertiumApplicator.hpp
	BinaryGrammar.cpp
	BinaryGrammar.hpp
	BinaryGrammar_read.cpp
	BinaryGrammar_read_10043.cpp
	BinaryGrammar_write.cpp
	Cohort.cpp
	Cohort.hpp
	CohortIterator.cpp
	CohortIterator.hpp
	ContextualTest.cpp
	ContextualTest.hpp
	FSTApplicator.cpp
	FSTApplicator.hpp
	FormatConverter.cpp
	FormatConverter.hpp
	Grammar.cpp
	Grammar.hpp
	GrammarApplicator.cpp
	GrammarApplicator.hpp
	GrammarApplicator_context.cpp
	GrammarApplicator_matchSet.cpp
	GrammarApplicator_reflow.cpp
	GrammarApplicator_runContextualTest.cpp
	GrammarApplicator_runGrammar.cpp
	GrammarApplicator_runRules.cpp
	GrammarWriter.cpp
	GrammarWriter.hpp
	IGrammarParser.hpp
	MathParser.hpp
	MatxinApplicator.cpp
	MatxinApplicator.hpp
	MweSplitApplicator.cpp
	MweSplitApplicator.hpp
	NicelineApplicator.cpp
	NicelineApplicator.hpp
	PlaintextApplicator.cpp
	PlaintextApplicator.hpp
	Profiler.cpp
	Profiler.hpp
	Reading.cpp
	Reading.hpp
	Relabeller.cpp
	Relabeller.hpp
	Rule.cpp
	Rule.hpp
	Set.cpp
	Set.hpp
	SingleWindow.cpp
	SingleWindow.hpp
	Strings.cpp
	Strings.hpp
	Tag.cpp
	Tag.hpp
	TagTrie.hpp
	TextualParser.cpp
	TextualParser.hpp
	Window.cpp
	Window.hpp
	bloomish.hpp
	cg3.h
	flat_unordered_map.hpp
	flat_unordered_set.hpp
	inlines.hpp
	interval_vector.hpp
	parser_helpers.hpp
	pool.hpp
	process.hpp
	scoped_stack.hpp
	sorted_vector.hpp
	stdafx.hpp
	streambuf.hpp
	uextras.cpp
	uextras.hpp
	version.hpp
	${POPEN_PLUS_CPP}
	)
if(WIN32 OR EMSCRIPTEN)
	set(LIBCG3_SOURCES
		"${CMAKE_SOURCE_DIR}/include/wordexp/wordexp.cpp"
		"${CMAKE_SOURCE_DIR}/include/wordexp/wordexp.h"
		${LIBCG3_SOURCES}
		)
endif()
if(WIN32)
	set(LIBCG3_SOURCES
		"${CMAKE_SOURCE_DIR}/include/getopt/getopt.cpp"
		"${CMAKE_SOURCE_DIR}/include/getopt/getopt.h"
		${LIBCG3_SOURCES}
		)
endif()

add_library(cg3 libcg3.cpp ${LIBCG3_SOURCES})
set_target_properties(cg3 PROPERTIES SOVERSION ${_cg3_VERSION_MAJOR})
cg3_link(cg3)
set(LINKLIB cg3)

add_executable(cg-comp cg-comp.cpp)
cg3_link(cg-comp)
target_link_libraries(cg-comp ${LINKLIB})

add_executable(cg-proc cg-proc.cpp)
cg3_link(cg-proc)
target_link_libraries(cg-proc ${LINKLIB})

add_executable(cg-relabel cg-relabel.cpp)
cg3_link(cg-relabel)
target_link_libraries(cg-relabel ${LINKLIB})

add_executable(cg-conv
	cg-conv.cpp
	options_conv.hpp
	options_parser.hpp
	)
cg3_link(cg-conv)
target_link_libraries(cg-conv ${LINKLIB})

add_executable(cg-mwesplit cg-mwesplit.cpp)
cg3_link(cg-mwesplit)
target_link_libraries(cg-mwesplit ${LINKLIB})

add_executable(cg-annotate cg-annotate.cpp)
cg3_link(cg-annotate)
target_link_libraries(cg-annotate ${LINKLIB})

add_executable(cg-merge-annotations cg-merge-annotations.cpp)
cg3_link(cg-merge-annotations)
target_link_libraries(cg-merge-annotations ${LINKLIB})

add_executable(vislcg3
	main.cpp
	options.hpp
	options_parser.hpp
	)
cg3_link(vislcg3)
target_link_libraries(vislcg3 ${LINKLIB})

add_executable(test_libcg3 test_libcg3.c)
target_link_libraries(test_libcg3 ${LINKLIB})

if(APPLE)
	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit cg-annotate cg-merge-annotations vislcg3)
		set("_file_${t}" $<TARGET_FILE:${t}>)
		add_custom_command(
			TARGET ${t}
			POST_BUILD
			COMMAND install_name_tool -change libcg3.0.dylib @rpath/libcg3.0.dylib ${_file_${t}}
			COMMAND install_name_tool -add_rpath @executable_path/ ${_file_${t}}
			COMMAND install_name_tool -add_rpath @executable_path/../${CMAKE_INSTALL_LIBDIR} ${_file_${t}}
			COMMAND install_name_tool -add_rpath @loader_path/../${CMAKE_INSTALL_LIBDIR} ${_file_${t}}
			COMMENT "Adding @rpath to ${t}"
			VERBATIM
		)
	endforeach()
endif()

add_test(t_libcg3 test_libcg3 "${CMAKE_CURRENT_SOURCE_DIR}/../test/T_Select/grammar.cg3")

install(TARGETS cg3 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES cg3.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv cg-annotate cg-merge-annotations vislcg3 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== debian/changelog ===
cg3 (1.5.0-1) unstable; urgency=medium

  * Update to latest upstream
  * Upstream URLs changed from visl.sdu.dk to edu.visl.dk
  * debian/control:
    + Updated Standards-Version to 4.7.2

 -- Tino Didriksen <tino@didriksen.cc>  Tue, 11 Mar 2025 16:26:02 +0100

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DH_OPTIONS
 export LC_ALL=C.UTF-8
 
-export "DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto"
+export "DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto reproducible=+fixfilepath"
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -20,6 +20,3 @@
 	find $(CURDIR) -type f -name '*.pyc' -exec rm -f '{}' \;
 	find $(CURDIR) -type f -name '*.pyo' -exec rm -f '{}' \;
 	find $(CURDIR) -type f -name '*.la' -exec rm -f '{}' \;
-
-override_dh_missing:
-	dh_missing --fail-missing
